import { useContext } from 'react'
import './Navigation.css'
import _ from 'lodash'
import { HALL, BEGIN } from '../Constant'
import tableData from '../views/CheckerboardData'
import GlobalSocketContext from '../provider/GlobalSocketContext'
import RevRoomContext from '../provider/RevRoomContext'
const tableDataTemplate = _.cloneDeep(tableData)
const Navigation = function () {
    const { room } = useContext(RevRoomContext)
    const socket = useContext(GlobalSocketContext)
    const beginGame = () => {
        socket.send(JSON.stringify({
            instruct: BEGIN,
            data:tableDataTemplate
        }))
    }
    const backHall = () =>{
        socket.send(JSON.stringify({
            instruct: HALL
        }))
    }
    return (
        <>
            <div className='nav-grid'>
                <div className='back-hall'>
                    <button onClick={backHall}>返回大厅</button>
                </div>
                <div className='nav-item'>
                    <img className='avatar' alt='' src={require("../assets/left.png")} />
                    <div className='text-box'>
                        <span className='user-text'>{(() => {
                            const localname = sessionStorage.getItem("username")
                            if (localname === room.whiteUsername) return "对手"
                            else return "黑棋"
                        })()}</span>
                        <span className='user-text'>{room.backUsername}</span>
                    </div>
                </div>
                <div className='nav-item'>
                    <button onClick={beginGame}
                        disabled={(()=>{
                            const localname = sessionStorage.getItem("username")
                            if ( room.status > 0 ) {
                                return true;
                            } else if ( room.backState === 2 && 
                                localname === room.backUsername ) {
                                return true      
                            } else if ( room.whiteState === 2 && 
                                localname === room.whiteUsername ) {
                                return true      
                            } else {
                                return false
                            }
                        })()}
                        className='beginGame'>{(() => {
                            if ( room.backState === 2 && room.whiteState !== 2 ) {
                                return '等待白棋确认'
                            } else if ( room.whiteState === 2 && room.backState !== 2 ) {
                                return '等待黑棋确认'
                            } else {
                                switch (room.status) {
                                    case 0: return '开始游戏'
                                    case 1: return '请黑方落子'
                                    case 2: return '请白方落子'
                                    default: return '加油!'
                                }
                            } 
                        })()} </button>
                </div>
                <div className='nav-item'>
                    <img className='avatar right-avatar' alt='' src={require("../assets/right.png")} />
                    <div className='text-box'>
                        <span className='user-text'>{(() => {
                            const localname = sessionStorage.getItem("username")
                            if (localname === room.backUsername) return "对手"
                            else return "白棋"
                        })()}</span>
                        <span className='user-text'>{room.whiteUsername}</span>
                    </div>
                </div>
            </div>
        </>
    )
}
export default Navigation